<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/GameObject.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">GameObject.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="GameObject_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef GameObject_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define GameObject_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Object_8h.html">Object.h</a>&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="classGameObject.html">   14</a></span>&#160;<span class="keyword">class </span><a class="code" href="classGameObject.html">GameObject</a> : <span class="keyword">public</span> <a class="code" href="classObject.html">Object</a> {</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <a class="code" href="classGameObject.html#a0348e3ee2e83d56eafca7a3547f432c4">GameObject</a>();</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="classGameObject.html#a224d4f6d9dd75c8a6f9d022eaf586fd9">   26</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classGameObject.html#a224d4f6d9dd75c8a6f9d022eaf586fd9">~GameObject</a>(){}</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classGameObject.html#afd237fc51b336232cd5d97ca0a3266ec">SetBoundBox</a>(<span class="keywordtype">int</span> Width,<span class="keywordtype">int</span> Height);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classGameObject.html#afe84ab4b266362535372065ed0aacdfb">GetBoundWidth</a>();</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classGameObject.html#acbf0266f9230693a470181d4ee9ef9e8">GetBoundHeight</a>();</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classGameObject.html#a14a2649fb1de4e3e705fb54df2df8f9b">SetMovementVector</a>(<span class="keywordtype">int</span> vx, <span class="keywordtype">int</span> vy);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classGameObject.html#a24428667f904a6445594d884476c67ac">GetMoveDirHorizontal</a>();</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classGameObject.html#a68ce660066e5dbc9c1ac9be4fabc558f">ObjectMove</a>();</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classGameObject.html#a8133e4ab74ef92b50c14c18382b2397e">Intersects</a>(<a class="code" href="classGameObject.html">GameObject</a> * obj);</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGameObject.html#af71762b88087efbed642c0a728b81792">Visit</a> (<a class="code" href="classCollisionVisitor.html">CollisionVisitor</a> * visitor) = 0;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGameObject.html#abfb8111c32e0c20d2f29d668730c101e">CollideWith</a> (<a class="code" href="classGameObject.html">GameObject</a> * collisionObject) = 0;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classGameObject.html#a209b156ef8eec011eba664f3987d4ff7">OnBorderCollision</a>();</div>
<div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="classGameObject.html#a2831bbdeef51b7dec1c886a3792a5021">   86</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classGameObject.html#a2831bbdeef51b7dec1c886a3792a5021">m_BoundBoxWidth</a>;</div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classGameObject.html#a478d95fa66433fb8b63e1de62df32a05">   87</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classGameObject.html#a478d95fa66433fb8b63e1de62df32a05">m_BoundBoxHeight</a>;</div>
<div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="classGameObject.html#a18cf227e1f9b1246ad72e555060f5602">   88</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classGameObject.html#a18cf227e1f9b1246ad72e555060f5602">m_MovementSpeed</a>; </div>
<div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="classGameObject.html#a06399d2e83dbed0bbcdd23a45708e743">   89</a></span>&#160;    std::chrono::time_point&lt;std::chrono::system_clock&gt; <a class="code" href="classGameObject.html#a06399d2e83dbed0bbcdd23a45708e743">m_LastMovementAt</a>; </div>
<div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classGameObject.html#aebfa0ceffe82ed29b0fd2ef37050e992">   90</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classGameObject.html#a4cfd998f5afb701fdd721c5e5a00897b">m_VectX</a>, <a class="code" href="classGameObject.html#aebfa0ceffe82ed29b0fd2ef37050e992">m_VectY</a>;</div>
<div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="classGameObject.html#abc176e5a277e67b70ba1d2292ade28c7">   91</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classGameObject.html#abc176e5a277e67b70ba1d2292ade28c7">m_DiagonalCounter</a>; </div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;};</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* GameObject_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassGameObject_html"><div class="ttname"><a href="classGameObject.html">GameObject</a></div><div class="ttdoc">Abstract class that represents GameObject with collision and movement properties.</div><div class="ttdef"><b>Definition:</b> GameObject.h:14</div></div>
<div class="ttc" id="aclassGameObject_html_a478d95fa66433fb8b63e1de62df32a05"><div class="ttname"><a href="classGameObject.html#a478d95fa66433fb8b63e1de62df32a05">GameObject::m_BoundBoxHeight</a></div><div class="ttdeci">int m_BoundBoxHeight</div><div class="ttdef"><b>Definition:</b> GameObject.h:87</div></div>
<div class="ttc" id="aclassGameObject_html_a68ce660066e5dbc9c1ac9be4fabc558f"><div class="ttname"><a href="classGameObject.html#a68ce660066e5dbc9c1ac9be4fabc558f">GameObject::ObjectMove</a></div><div class="ttdeci">void ObjectMove()</div><div class="ttdoc">Moves GameObject in direction of a movement vector.</div><div class="ttdef"><b>Definition:</b> GameObject.cpp:36</div></div>
<div class="ttc" id="aclassGameObject_html_a224d4f6d9dd75c8a6f9d022eaf586fd9"><div class="ttname"><a href="classGameObject.html#a224d4f6d9dd75c8a6f9d022eaf586fd9">GameObject::~GameObject</a></div><div class="ttdeci">virtual ~GameObject()</div><div class="ttdoc">Virtual destructor that ensures correct memory handling in derived classes.</div><div class="ttdef"><b>Definition:</b> GameObject.h:26</div></div>
<div class="ttc" id="aclassGameObject_html_abc176e5a277e67b70ba1d2292ade28c7"><div class="ttname"><a href="classGameObject.html#abc176e5a277e67b70ba1d2292ade28c7">GameObject::m_DiagonalCounter</a></div><div class="ttdeci">int m_DiagonalCounter</div><div class="ttdef"><b>Definition:</b> GameObject.h:91</div></div>
<div class="ttc" id="aclassGameObject_html_a06399d2e83dbed0bbcdd23a45708e743"><div class="ttname"><a href="classGameObject.html#a06399d2e83dbed0bbcdd23a45708e743">GameObject::m_LastMovementAt</a></div><div class="ttdeci">std::chrono::time_point&lt; std::chrono::system_clock &gt; m_LastMovementAt</div><div class="ttdef"><b>Definition:</b> GameObject.h:89</div></div>
<div class="ttc" id="aclassGameObject_html_a24428667f904a6445594d884476c67ac"><div class="ttname"><a href="classGameObject.html#a24428667f904a6445594d884476c67ac">GameObject::GetMoveDirHorizontal</a></div><div class="ttdeci">int GetMoveDirHorizontal()</div><div class="ttdef"><b>Definition:</b> GameObject.cpp:32</div></div>
<div class="ttc" id="aclassObject_html"><div class="ttname"><a href="classObject.html">Object</a></div><div class="ttdoc">Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...</div><div class="ttdef"><b>Definition:</b> Object.h:10</div></div>
<div class="ttc" id="aclassGameObject_html_a4cfd998f5afb701fdd721c5e5a00897b"><div class="ttname"><a href="classGameObject.html#a4cfd998f5afb701fdd721c5e5a00897b">GameObject::m_VectX</a></div><div class="ttdeci">int m_VectX</div><div class="ttdef"><b>Definition:</b> GameObject.h:90</div></div>
<div class="ttc" id="aclassGameObject_html_afd237fc51b336232cd5d97ca0a3266ec"><div class="ttname"><a href="classGameObject.html#afd237fc51b336232cd5d97ca0a3266ec">GameObject::SetBoundBox</a></div><div class="ttdeci">void SetBoundBox(int Width, int Height)</div><div class="ttdoc">Sets the bound box for collision handling.</div><div class="ttdef"><b>Definition:</b> GameObject.cpp:14</div></div>
<div class="ttc" id="aclassGameObject_html_abfb8111c32e0c20d2f29d668730c101e"><div class="ttname"><a href="classGameObject.html#abfb8111c32e0c20d2f29d668730c101e">GameObject::CollideWith</a></div><div class="ttdeci">virtual void CollideWith(GameObject *collisionObject)=0</div><div class="ttdoc">Creates Visitor object and passes collisionObject parameter.</div></div>
<div class="ttc" id="aclassGameObject_html_aebfa0ceffe82ed29b0fd2ef37050e992"><div class="ttname"><a href="classGameObject.html#aebfa0ceffe82ed29b0fd2ef37050e992">GameObject::m_VectY</a></div><div class="ttdeci">int m_VectY</div><div class="ttdef"><b>Definition:</b> GameObject.h:90</div></div>
<div class="ttc" id="aObject_8h_html"><div class="ttname"><a href="Object_8h.html">Object.h</a></div></div>
<div class="ttc" id="aclassGameObject_html_a8133e4ab74ef92b50c14c18382b2397e"><div class="ttname"><a href="classGameObject.html#a8133e4ab74ef92b50c14c18382b2397e">GameObject::Intersects</a></div><div class="ttdeci">void Intersects(GameObject *obj)</div><div class="ttdoc">Whenever GameObject intersects with obj it resolves collision with use of double dispatch visitor pat...</div><div class="ttdef"><b>Definition:</b> GameObject.cpp:68</div></div>
<div class="ttc" id="aclassGameObject_html_a14a2649fb1de4e3e705fb54df2df8f9b"><div class="ttname"><a href="classGameObject.html#a14a2649fb1de4e3e705fb54df2df8f9b">GameObject::SetMovementVector</a></div><div class="ttdeci">void SetMovementVector(int vx, int vy)</div><div class="ttdoc">Sets a movement vector.</div><div class="ttdef"><b>Definition:</b> GameObject.cpp:27</div></div>
<div class="ttc" id="aclassGameObject_html_a18cf227e1f9b1246ad72e555060f5602"><div class="ttname"><a href="classGameObject.html#a18cf227e1f9b1246ad72e555060f5602">GameObject::m_MovementSpeed</a></div><div class="ttdeci">int m_MovementSpeed</div><div class="ttdef"><b>Definition:</b> GameObject.h:88</div></div>
<div class="ttc" id="aclassGameObject_html_a209b156ef8eec011eba664f3987d4ff7"><div class="ttname"><a href="classGameObject.html#a209b156ef8eec011eba664f3987d4ff7">GameObject::OnBorderCollision</a></div><div class="ttdeci">virtual void OnBorderCollision()</div><div class="ttdoc">Destroys GameObject if it collides with top and bottom border.</div><div class="ttdef"><b>Definition:</b> GameObject.cpp:87</div></div>
<div class="ttc" id="aclassGameObject_html_a0348e3ee2e83d56eafca7a3547f432c4"><div class="ttname"><a href="classGameObject.html#a0348e3ee2e83d56eafca7a3547f432c4">GameObject::GameObject</a></div><div class="ttdeci">GameObject()</div><div class="ttdoc">Construct a new GameObject and initializes internal variables.</div><div class="ttdef"><b>Definition:</b> GameObject.cpp:7</div></div>
<div class="ttc" id="aclassGameObject_html_acbf0266f9230693a470181d4ee9ef9e8"><div class="ttname"><a href="classGameObject.html#acbf0266f9230693a470181d4ee9ef9e8">GameObject::GetBoundHeight</a></div><div class="ttdeci">int GetBoundHeight()</div><div class="ttdef"><b>Definition:</b> GameObject.cpp:23</div></div>
<div class="ttc" id="aclassCollisionVisitor_html"><div class="ttname"><a href="classCollisionVisitor.html">CollisionVisitor</a></div><div class="ttdoc">Abstract class of double dispatch visitor design patter.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:18</div></div>
<div class="ttc" id="aclassGameObject_html_afe84ab4b266362535372065ed0aacdfb"><div class="ttname"><a href="classGameObject.html#afe84ab4b266362535372065ed0aacdfb">GameObject::GetBoundWidth</a></div><div class="ttdeci">int GetBoundWidth()</div><div class="ttdef"><b>Definition:</b> GameObject.cpp:19</div></div>
<div class="ttc" id="aclassGameObject_html_af71762b88087efbed642c0a728b81792"><div class="ttname"><a href="classGameObject.html#af71762b88087efbed642c0a728b81792">GameObject::Visit</a></div><div class="ttdeci">virtual void Visit(CollisionVisitor *visitor)=0</div><div class="ttdoc">Pure virtual function for accepting visitor.</div></div>
<div class="ttc" id="aclassGameObject_html_a2831bbdeef51b7dec1c886a3792a5021"><div class="ttname"><a href="classGameObject.html#a2831bbdeef51b7dec1c886a3792a5021">GameObject::m_BoundBoxWidth</a></div><div class="ttdeci">int m_BoundBoxWidth</div><div class="ttdef"><b>Definition:</b> GameObject.h:86</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
